/*
 * hchserverR.c
 * demo tool for hchlib_1.0.h
 */

#include "hchlib.h"
#include <stdlib.h>
#include <dirent.h>

#include <fcntl.h>

#define PERMS 0666
#define BACKLOG 15
#define PORTA	 1234
#define MAX  16000
#define MAX_PATH 256

int listdir(char *, char *);

int 
main(int argc, char **argv)
{
  int buffer_len, path_len;	
	char buffer[MAX]; 
	char lista[MAX], mime[MAX_MIME], name[MAX_PATH], path[MAX_PATH], file[MAX_PATH], transfer[MAX_TENC];
	int sd, csd, i, j, fout, n, k;
	
	switch(argc){
		case 1 :
			strcpy(path, "./");
		  break;
		case 2 :
			strcpy(path, argv[1]);
			break;
		default:
			printf("Usage: %s <dir_path>\n"
						 "dir_path   set working path (current if omitted)\n", argv[0]);
		return 1;
	}
	
		
	if((sd = listen_hchlib(PORTA, BACKLOG)) < 0) return 1;
		
	for(n=0; n < 32768; n++){
    csd = accept_hchlib(sd);
		
  	j=recv_hchlib(csd, buffer, &buffer_len, transfer, mime);
		if(j<0){
			continue;
		}
		
		itoa(name, n);
		strcat(name, ".");
		transfer[3] = '\0';
		strcpy(file, path);
		if((fout = creat(strcat(file, strcat(name, transfer)), PERMS)) == -1){
			printf("file creation error\n");
			continue;
		}

		write(fout, buffer, buffer_len);
  }
  return 0;
}
